// Set up variables
var score = 0;
var timeLeft = 30;
var moles = [];
var numMoles = 6;
var moleSize = 50;
var level = "1";
let pingSound;
let backgroundSound;
var mode;

function preload() {
  pingSound = loadSound("../assets/click.mp3");  
  backgroundSound = loadSound("../assets/music.mp3");
}

function setup() {
  mode = 0;
  createCanvas(500, 500);
  getAudioContext().suspend();
  pingSound = loadSound("../assets/click.mp3");
  backgroundSound.loop();
  backgroundSound = loadSound("../assets/music.mp3");
  
  // Create moles
  for (var i = 0; i < numMoles; i++) {
    moles.push(new Mole(random(width), random(height), moleSize));
  }
}

function draw() {
  if (mode==0){
    background(220)
    textAlign(CENTER);
    textSize(40);
    fill(255);
    text('press enter to start', width/2,height/2);
    textSize(25);
    text('RULES: click the moles to score points', width/2, height/2+100);
    textSize(50);
    fill(150,64,51);
    text('WHACKA MOLE', width/2, height/2-100);
    
  }
    if (mode==1){
      background(220);

  // Draw score and time left
  textAlign(CENTER);
  textSize(20);
  fill(0);
  text("Score: " + score, 49, 30);
  text("Time left: " + timeLeft, 65, 60);
  text(`Level: ${level}`, 450, 30);
  

  // Draw moles
  for (var i = 0; i < moles.length; i++) {
    moles[i].show();
  }

  // Update time left
  if (frameCount % 60 == 0 && timeLeft > 0) {
    timeLeft--;
  }

  // Check for game over
  if (timeLeft == 0) {
    textAlign(CENTER);
    noLoop();
    textSize(20);0-
    background(225);
    fill(255);
    text("refresh the page to play again", width/2, height/2-75);
    textSize(40)
    text(`Score: ${score}`, width/2, height/2+75);
    fill(255,0,0);
    textSize(50);
    text("GAMEOVER", width/2, height/2);
    textSize(10);
    fill(0);
  }
  


  // Check for level change
  if (score >= 20 && level == "1") {
    level = "2", 
    numMoles = 7;
    moleSize = 30;
    moles = [];
    for (var i = 0; i < numMoles; i++) {
      moles.push(new Mole(random(width), random(height), moleSize));
    }
  }
}

    }
    
  

function keyPressed(){
  if (keyCode===ENTER){
    mode=1;
  }
}


function mousePressed() {
  // Check for click on mole
  for (var i = 0; i < moles.length; i++) {
    if (moles[i].contains(mouseX, mouseY)) {
      pingSound.play();
      userStartAudio();
      score++;
      moles[i].whack();
      moles[i] = new Mole(random(width), random(height), moleSize);
    }
  }
}

class Mole {
  constructor(x, y, size) {
    this.x = x;
    this.y = y;
    this.size = size;
    this.up = false;
  }

  show() {
    if (this.up) {
      fill(125, 125, 0);
      ellipse(this.x, this.y, this.size);
    } else {
      fill(150, 75, 0);
      ellipse(this.x, this.y, this.size);
    }
  }

  contains(px, py) {
    var d = dist(px, py, this.x, this.y);
    if (d < this.size/2) {
      return true;
    } else {
      return false;
    }
  }

  whack() {
    this.up = false;
  }
}
